const int trig = 3;                       //trigger-pin is D3
const int echo = 2;                       //echo-pin is D2
float distance;                           
float duration;


void setup() {
  pinMode(trig, OUTPUT);                  //set the trigger-pin to output 
  pinMode(echo, INPUT);                   //set the echo-pin to input
  Serial.begin(9600);                     //begin the serial communication at 9600 boud
}                                         //(serial monitor must be set to 9600 too)

void loop(){
  digitalWrite(trig,LOW);                   
  delayMicroseconds(2);
  digitalWrite(trig,HIGH);                    
  delayMicroseconds(11);                  //trigger must be on HIGH for at least 10us    
  digitalWrite(trig,LOW);
  duration = pulseIn(echo,HIGH,50000);    //measure the pulseduration on the echo-pin (50ms timeout)
  distance = duration/58.2;               //calculate the distance in cm(see theory)
  if(distance > 1 && distance < 401){     //if the distance is in range
    Serial.print(distance/2.54,1);        //print it in inch with one decimal-place
    Serial.println(" inch");
  }
  else{
    Serial.println("not in range!");      
    }
  delay(100);                              //wait 100ms before next cycle
}
