const int trig = 3;
const int echo = 2;
float vals[5];                        //arry to hold last 5 values
float tempratureC = 20.0;             //operating temprature in °C
int counter = 0;                      //loop-counter 0-4; 

void setup() {
  pinMode(trig, OUTPUT);
  pinMode(echo, INPUT);
  Serial.begin(9600);
}

void loop(){
    vals[counter] = getDistance();       //save the distance in the current array element
    printDistance(calcAv());             //print out the calculated distance
    count();                             //update counter 
    delay(100);                         
}

void count(){
    if(counter < 4){                     //if the counter hasn't reached 4 count on  
      counter++;
    }
    else{                               //else set it back
      counter = 0;
    }
}

//this function searches for the min and max of the array and calculates the
//avarage of the remaining 3 values
float calcAv(){                       
   int indexmin = 0;                       //starting index of min value       
   int indexmax = 4;                       //starting index of max value       
   float sum = 0;                          //variable to hold the sum
  
  for(int i=0; i<5; i++){                 //loop through the array  
    if(vals[i]<vals[indexmin]){           //if the value is smaller than the min it's the new min  
      indexmin = i;
    }
     if(vals[i]>vals[indexmax]){          //if the value is bigger than the max it's the new max
      indexmax = i;
    }
  }
  for(int i=0; i<5; i++){                  //loop through the array again 
    if(i != indexmin && i != indexmax){    //don't sum up min and max 
      sum += vals[i];
    }
  }
  return sum/3.0;                          //return the average of the 3 remaining values 
}

void printDistance(float dist){            //print the distance if in range
  if(dist > 1 && dist < 401){
    Serial.print(dist,1);
    Serial.println(" cm");
  }
  else{
    Serial.println("not in range!");
  }
}

float getDistance(){
  trigger();
  float duration = pulseIn(echo,HIGH,50000);
  float distance = duration*(331.5+0.6*tempratureC)/20000;  //see theory
  return distance;
}

void trigger(){                           //trigger-function
  digitalWrite(trig,LOW);
  delayMicroseconds(2);
  digitalWrite(trig,HIGH);
  delayMicroseconds(11);
  digitalWrite(trig,LOW);
}

